//
//  AppDelegate.m
//  BaiduRecommendStopDemo
//
//  Created by v_wangdachuan on 2022/11/14.
//

#import "AppDelegate.h"
#import "ViewController.h"
#import "BaseNavigationController.h"
@interface AppDelegate ()

@property (nonatomic, strong) BMKMapManager *mapManager; //主引擎类

@end

@implementation AppDelegate


- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    // Override point for customization after application launch.
    
    [[BMKLocationAuth sharedInstance] setAgreePrivacy:YES];
    [BMKMapManager setAgreePrivacy:YES];
    // 初始化定位SDK
    [[BMKLocationAuth sharedInstance] checkPermisionWithKey:@"请输入您的AK" authDelegate:nil];
    
    //要使用百度地图，请先启动BMKMapManager
    _mapManager = [[BMKMapManager alloc] init];
    
    /**
     百度地图SDK所有API均支持百度坐标（BD09）和国测局坐标（GCJ02），用此方法设置您使用的坐标类型.
     默认是BD09（BMK_COORDTYPE_BD09LL）坐标.
     如果需要使用GCJ02坐标，需要设置CoordinateType为：BMK_COORDTYPE_COMMON.
     */
    if ([BMKMapManager setCoordinateTypeUsedInBaiduMapSDK:BMK_COORDTYPE_BD09LL]) {
        NSLog(@"经纬度类型设置成功");
    } else {
        NSLog(@"经纬度类型设置失败");
    }
    
    //启动引擎并设置AK并设置delegate
    BOOL result = [_mapManager start:@"请输入您的AK" generalDelegate:nil];
    if (!result) {
        NSLog(@"启动引擎失败");
    }
    
    ViewController *rootvc = [[ViewController alloc] init];
    BaseNavigationController *navigationController = [[BaseNavigationController alloc] initWithRootViewController:rootvc];
    [self.window setRootViewController:navigationController];
    self.window.backgroundColor = [UIColor whiteColor];
    [self.window makeKeyAndVisible];
    
    return YES;
}



@end
