//
//  BaseNavigationController.m
//  BaiduRecommendStopDemo
//
//  Created by v_wangdachuan on 2022/11/15.
//

#import "BaseNavigationController.h"

@interface BaseNavigationController ()

@end

@implementation BaseNavigationController

- (instancetype)initWithRootViewController:(UIViewController *)rootViewController {
    if (self = [super initWithRootViewController:rootViewController]) {
        NSDictionary *titleTextAttributes = @{ NSForegroundColorAttributeName:[UIColor colorWithRed:51/255.0 green:51/255.0 blue:51/255.0 alpha:1.0]};
        if (@available(iOS 13.0, *)) {
            
            UINavigationBarAppearance *appearance = [UINavigationBarAppearance new];
            //导航栏颜色
            appearance.backgroundColor = [UIColor clearColor];
            //导航栏字体颜色
            appearance.titleTextAttributes = titleTextAttributes;
            //隐藏导航返回按钮文字
            UIBarButtonItemAppearance *barButtonItemAppearance = [UIBarButtonItemAppearance new];
            barButtonItemAppearance.normal.titlePositionAdjustment = UIOffsetMake(-1000, 0);
            appearance.backButtonAppearance = barButtonItemAppearance;
            self.navigationBar.standardAppearance = appearance;
            self.navigationBar.scrollEdgeAppearance = appearance;
        } else {
            //导航栏颜色
            self.navigationBar.barTintColor = [UIColor whiteColor];

            //导航栏字体颜色
            [[UINavigationBar appearance] setTitleTextAttributes:titleTextAttributes];
            //隐藏导航返回按钮文字
            [[UIBarButtonItem appearance] setBackButtonTitlePositionAdjustment:UIOffsetMake(-1000, 0)
                                                                 forBarMetrics:UIBarMetricsDefault];
        }
        //设置导航返回按钮颜色
        self.navigationBar.tintColor = [UIColor colorWithRed:51/255.0 green:51/255.0 blue:51/255.0 alpha:1.0];
    }
    return self;
}
@end
