//
//  BMKCustomPaoPaoView.m
//  BaiduRecommendStopDemo
//
//  Created by v_wangdachuan on 2022/11/15.
//

#import "BMKCustomPaoPaoView.h"

@implementation BMKCustomPaoPaoView

- (instancetype)initWithFrame:(CGRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        [self configUI];
        self.backgroundColor = [UIColor clearColor];
    }
    return self;
}

- (void)configUI {
    UIImageView *bgImageView = [[UIImageView alloc] initWithFrame:self.bounds];
    bgImageView.image = [UIImage imageNamed:@"carCalloutBgView"];
    bgImageView.userInteractionEnabled = YES;
    [self addSubview:bgImageView];
    
    UIButton *panoBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    panoBtn.layer.masksToBounds = YES;
    panoBtn.frame = CGRectMake(18, 12, 35, 35);
    panoBtn.layer.cornerRadius = 17.5;
    [panoBtn setImage:_panoImage forState:UIControlStateNormal];
    [panoBtn setTitle:@"查看全景" forState:UIControlStateNormal];
    [panoBtn setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    panoBtn.titleLabel.font = [UIFont systemFontOfSize:6];
    panoBtn.titleEdgeInsets = UIEdgeInsetsMake(0, 0, 0, 0);
    panoBtn.tag = 998;
    [panoBtn addTarget:self action:@selector(btnClick) forControlEvents:UIControlEventTouchUpInside];
    [bgImageView addSubview:panoBtn];
    
    UILabel *nameLabel = [[UILabel alloc] initWithFrame:CGRectMake(60, 12, CGRectGetWidth(self.frame) - 75, 20)];
    nameLabel.font = [UIFont systemFontOfSize:12];
    nameLabel.tag = 999;
    [bgImageView addSubview:nameLabel];
    
    UILabel *timeLabel = [[UILabel alloc] initWithFrame:CGRectMake(60, CGRectGetMaxY(nameLabel.frame) + 5, CGRectGetWidth(self.frame) - 75, 10)];
    timeLabel.text = @"预计1分钟上车";
    timeLabel.font = [UIFont systemFontOfSize:9];
    [bgImageView addSubview:timeLabel];
}

- (void)setPanoImage:(UIImage *)panoImage {
    _panoImage = panoImage;
    UIButton *btn = (UIButton *)[self viewWithTag:998];
    [btn setImage:_panoImage forState:UIControlStateNormal];
}

- (void)btnClick {
    if (self.block) {
        self.block();
    }
}

- (void)setName:(NSString *)name {
    _name = name;
    UILabel *label = (UILabel *)[self viewWithTag:999];
    label.text = _name;
}

@end
