//
//  BMKSugResultTableViewCell.m
//  PassengerDemo
//
//  Created by baidu on 2021/2/20.
//  Copyright © 2021 baidu. All rights reserved.
//

#import "BMKSugResultTableViewCell.h"
@interface BMKSugResultTableViewCell () <BMKPoiSearchDelegate>
@property (nonatomic, strong)UIImageView *leftImageView;
@property (nonatomic, strong)UILabel *nameLabel;
@property (nonatomic, strong)UILabel *distanceLabel;
@property (nonatomic, strong)UILabel *detailLabel;
@property (nonatomic, strong)UIStackView *containerView;
@property (nonatomic, assign)NSLayoutConstraint *containerViewHeightConstraint;
@end
@implementation BMKSugResultTableViewCell
- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    if (self = [super initWithStyle:style reuseIdentifier:reuseIdentifier]) {
        [self.contentView addSubview:self.leftImageView];
        [self.contentView addSubview:self.nameLabel];
        [self.contentView addSubview:self.distanceLabel];
        [self.contentView addSubview:self.detailLabel];
        [self.contentView addSubview:self.containerView];
    }
    return self;
}

- (void)layoutSubviews {
    [super layoutSubviews];
    [self setupConstraints];
}

- (void)setupConstraints {
    [self.contentView addConstraint:[NSLayoutConstraint constraintWithItem:self.leftImageView attribute:NSLayoutAttributeTop relatedBy:NSLayoutRelationEqual toItem:self.contentView attribute:NSLayoutAttributeTop multiplier:1 constant:21]];
    [self.contentView addConstraint:[NSLayoutConstraint constraintWithItem:self.leftImageView attribute:NSLayoutAttributeLeft relatedBy:NSLayoutRelationEqual toItem:self.contentView attribute:NSLayoutAttributeLeft multiplier:1 constant:21.4]];
    [self.contentView addConstraint:[NSLayoutConstraint constraintWithItem:self.leftImageView attribute:NSLayoutAttributeWidth relatedBy:NSLayoutRelationEqual toItem:nil attribute:NSLayoutAttributeNotAnAttribute multiplier:1 constant:10]];
    [self.contentView addConstraint:[NSLayoutConstraint constraintWithItem:self.leftImageView attribute:NSLayoutAttributeHeight relatedBy:NSLayoutRelationEqual toItem:nil attribute:NSLayoutAttributeNotAnAttribute multiplier:1 constant:12]];
    
    
    [self.contentView addConstraint:[NSLayoutConstraint constraintWithItem:self.nameLabel attribute:NSLayoutAttributeTop relatedBy:NSLayoutRelationEqual toItem:self.contentView attribute:NSLayoutAttributeTop multiplier:1 constant:10]];
    [self.contentView addConstraint:[NSLayoutConstraint constraintWithItem:self.nameLabel attribute:NSLayoutAttributeLeft relatedBy:NSLayoutRelationEqual toItem:self.leftImageView attribute:NSLayoutAttributeRight multiplier:1 constant:10]];
    [self.contentView addConstraint:[NSLayoutConstraint constraintWithItem:self.nameLabel attribute:NSLayoutAttributeRight relatedBy:NSLayoutRelationEqual toItem:self.distanceLabel attribute:NSLayoutAttributeRight multiplier:1 constant:10]];
    [self.contentView addConstraint:[NSLayoutConstraint constraintWithItem:self.nameLabel attribute:NSLayoutAttributeHeight relatedBy:NSLayoutRelationEqual toItem:nil attribute:NSLayoutAttributeNotAnAttribute multiplier:1 constant:20]];
    
    [self.contentView addConstraint:[NSLayoutConstraint constraintWithItem:self.distanceLabel attribute:NSLayoutAttributeTop relatedBy:NSLayoutRelationEqual toItem:self.nameLabel attribute:NSLayoutAttributeTop multiplier:1 constant:0]];
    [self.contentView addConstraint:[NSLayoutConstraint constraintWithItem:self.distanceLabel attribute:NSLayoutAttributeRight relatedBy:NSLayoutRelationEqual toItem:self.contentView attribute:NSLayoutAttributeRight multiplier:1 constant:-10]];
    [self.contentView addConstraint:[NSLayoutConstraint constraintWithItem:self.distanceLabel attribute:NSLayoutAttributeWidth relatedBy:NSLayoutRelationEqual toItem:nil attribute:NSLayoutAttributeNotAnAttribute multiplier:1 constant:100]];
    [self.contentView addConstraint:[NSLayoutConstraint constraintWithItem:self.distanceLabel attribute:NSLayoutAttributeHeight relatedBy:NSLayoutRelationEqual toItem:nil attribute:NSLayoutAttributeNotAnAttribute multiplier:1 constant:20]];
    
    [self.contentView addConstraint:[NSLayoutConstraint constraintWithItem:self.detailLabel attribute:NSLayoutAttributeTop relatedBy:NSLayoutRelationEqual toItem:self.nameLabel attribute:NSLayoutAttributeBottom multiplier:1 constant:0]];
    [self.contentView addConstraint:[NSLayoutConstraint constraintWithItem:self.detailLabel attribute:NSLayoutAttributeLeft relatedBy:NSLayoutRelationEqual toItem:self.nameLabel attribute:NSLayoutAttributeLeft multiplier:1 constant:0]];
    [self.contentView addConstraint:[NSLayoutConstraint constraintWithItem:self.detailLabel attribute:NSLayoutAttributeRight relatedBy:NSLayoutRelationEqual toItem:self.contentView attribute:NSLayoutAttributeRight multiplier:1 constant:-10]];
    [self.contentView addConstraint:[NSLayoutConstraint constraintWithItem:self.detailLabel attribute:NSLayoutAttributeHeight relatedBy:NSLayoutRelationEqual toItem:nil attribute:NSLayoutAttributeNotAnAttribute multiplier:1 constant:20]];
    
    [self.contentView addConstraint:[NSLayoutConstraint constraintWithItem:self.containerView attribute:NSLayoutAttributeTop relatedBy:NSLayoutRelationEqual toItem:self.detailLabel attribute:NSLayoutAttributeBottom multiplier:1 constant:10]];
    [self.contentView addConstraint:[NSLayoutConstraint constraintWithItem:self.containerView attribute:NSLayoutAttributeBottom relatedBy:NSLayoutRelationEqual toItem:self.contentView attribute:NSLayoutAttributeBottom multiplier:1 constant:-10]];
    [self.contentView addConstraint:[NSLayoutConstraint constraintWithItem:self.containerView attribute:NSLayoutAttributeLeft relatedBy:NSLayoutRelationEqual toItem:self.contentView attribute:NSLayoutAttributeLeft multiplier:1 constant:40]];
    [self.contentView addConstraint:[NSLayoutConstraint constraintWithItem:self.containerView attribute:NSLayoutAttributeRight relatedBy:NSLayoutRelationEqual toItem:self.contentView attribute:NSLayoutAttributeRight multiplier:1 constant:-40]];
    self.containerView.axis = UILayoutConstraintAxisVertical;
    self.containerView.spacing = 10;
    self.containerView.distribution = UIStackViewDistributionFillEqually;
//    self.containerView.alignment = UIStackViewAlignmentFirstBaseline;
//    self.containerViewHeight = 0;
}

//- (void)setContainerViewHeight:(CGFloat)containerViewHeight {
//    if (_containerViewHeight == containerViewHeight) {
//        return;
//    }
//    _containerViewHeight = containerViewHeight;
//    [self.contentView removeConstraint:self.containerViewHeightConstraint];
//    self.containerViewHeightConstraint = [NSLayoutConstraint constraintWithItem:self.containerView attribute:NSLayoutAttributeHeight relatedBy:NSLayoutRelationEqual toItem:nil attribute:NSLayoutAttributeNotAnAttribute multiplier:1 constant:_containerViewHeight];
//    [self.contentView addConstraint:self.containerViewHeightConstraint];
//}

- (UIImageView *)leftImageView {
    if (!_leftImageView) {
        _leftImageView = [[UIImageView alloc] init];
        [_leftImageView setImage:[UIImage imageNamed:@"address"]];
        _leftImageView.translatesAutoresizingMaskIntoConstraints = NO;
    }
    return _leftImageView;
}

- (UILabel *)nameLabel {
    if (!_nameLabel) {
        _nameLabel = [[UILabel alloc] init];
        [_nameLabel setFont:[UIFont fontWithName:@"PingFangSC-Regular" size:15]];
        [_nameLabel setTextColor:[UIColor colorWithRed:51/255.0 green:51/255.0 blue:51/255.0 alpha:1.0]];
        [_nameLabel setTextAlignment:NSTextAlignmentLeft];
        [_nameLabel setLineBreakMode:NSLineBreakByTruncatingTail];
        _nameLabel.translatesAutoresizingMaskIntoConstraints = NO;
    }
    return _nameLabel;
}

- (UILabel *)detailLabel {
    if (!_detailLabel) {
        _detailLabel = [[UILabel alloc] init];
        [_detailLabel setFont:[UIFont fontWithName:@"PingFangSC-Regular" size:13]];
        [_detailLabel setTextColor:[UIColor colorWithWhite:0.506 alpha:1]];
        [_detailLabel setTextAlignment:NSTextAlignmentLeft];
        [_detailLabel setLineBreakMode:NSLineBreakByTruncatingTail];
        _detailLabel.translatesAutoresizingMaskIntoConstraints = NO;
    }
    return _detailLabel;
}

- (UILabel *)distanceLabel {
    if (!_distanceLabel) {
        _distanceLabel = [[UILabel alloc] init];
        [_distanceLabel setFont:[UIFont systemFontOfSize:14]];
        [_distanceLabel setTextColor:[UIColor darkGrayColor]];
        [_distanceLabel setTextAlignment:NSTextAlignmentRight];
        [_distanceLabel setLineBreakMode:NSLineBreakByTruncatingTail];
        _distanceLabel.translatesAutoresizingMaskIntoConstraints = NO;
    }
    return _distanceLabel;
}

- (UIStackView *)containerView {
    if (!_containerView) {
        _containerView = [[UIStackView alloc] init];
        _containerView.translatesAutoresizingMaskIntoConstraints = NO;
    }
    return _containerView;
}

- (void)awakeFromNib {
    [super awakeFromNib];
    // Initialization code
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];
    if (selected) {
        if (self.suggestionInfo.uid.length > 0) {
            [self searchDetailInfoWithUid:self.suggestionInfo.uid];
        } else {
            if (self.completionHandler) {
                self.completionHandler(self.suggestionInfo);
            }
        }
    }
    
}

- (void)setSuggestionInfo:(BMKSuggestionInfo *)suggestionInfo {
    _suggestionInfo = suggestionInfo;
    _nameLabel.text = _suggestionInfo.key ? : @"";
    _detailLabel.text = [NSString stringWithFormat:@"%@ %@", _suggestionInfo.tag ? : @"", _suggestionInfo.address ? : @""];
    for (UIView *view in self.containerView.arrangedSubviews) {
        [view removeFromSuperview];
    }
    for (int i = 0; i <= _suggestionInfo.children.count / 3 && _suggestionInfo.children.count > 0; i ++) {
        if (i == _suggestionInfo.children.count / 3 && _suggestionInfo.children.count % 3 == 0 && i != 0) {
            break;
        }
        UIStackView *stackView = [[UIStackView alloc] init];
        stackView.spacing = 10;
        stackView.distribution = UIStackViewDistributionFillEqually;
        for (int j = 0; (i == _suggestionInfo.children.count / 3 ? j < _suggestionInfo.children.count % 3 : j < 3); j++) {
            BMKSuggestionChildrenInfo *info = _suggestionInfo.children[i*3 + j];
            UIButton *childrenInfoButton = [[UIButton alloc] init];
            [childrenInfoButton setTitle:info.showName forState:UIControlStateNormal];
            [childrenInfoButton.titleLabel setFont:[UIFont fontWithName:@"PingFangSC-Regular" size:12]];
            [childrenInfoButton setTitleColor:[UIColor colorWithWhite:51/255.0 alpha:1.0] forState:UIControlStateNormal];
            [childrenInfoButton setTitleColor:[UIColor colorWithWhite:0.9 alpha:1.0] forState:UIControlStateSelected];
            childrenInfoButton.layer.cornerRadius = 15;
            childrenInfoButton.layer.borderColor = [UIColor colorWithWhite:218/255.0 alpha:1].CGColor;
            childrenInfoButton.layer.borderWidth = 1;
            [childrenInfoButton setBackgroundColor:[UIColor whiteColor]];
            [childrenInfoButton addTarget:self action:@selector(childrenInfoButtonAction:) forControlEvents:UIControlEventTouchUpInside];
            childrenInfoButton.tag = i*3 + j;
            childrenInfoButton.translatesAutoresizingMaskIntoConstraints = NO;
            childrenInfoButton.titleLabel.lineBreakMode = NSLineBreakByTruncatingMiddle;
            [stackView addArrangedSubview:childrenInfoButton];
        }
        [self.containerView addArrangedSubview:stackView];
    }
    
    /// 暂无距离信息
    //_distanceLabel.text = @"";
}

- (void)childrenInfoButtonAction:(UIButton *)sender {
    sender.selected = !sender.selected;
    if (sender.selected) {
        [sender setBackgroundColor:[UIColor colorWithRed:44/255.0 green:129/255.0 blue:1.0 alpha:1.0]];
        sender.layer.borderWidth = 0;
    } else {
        [sender setBackgroundColor:[UIColor whiteColor]];
        sender.layer.borderWidth = 1;
    }
    BMKSuggestionChildrenInfo *info = _suggestionInfo.children[sender.tag];
    [self searchDetailInfoWithUid:info.uid];
}

/// poi详情检索
- (void)searchDetailInfoWithUid:(NSString *)uid {
    if (uid.length == 0) {
        return;
    }
    
    BMKPOIDetailSearchOption *option = [[BMKPOIDetailSearchOption alloc] init];
    option.poiUIDs = @[uid];
    option.scope = BMK_POI_SCOPE_DETAIL_INFORMATION;
    BMKPoiSearch *detailSearch = [[BMKPoiSearch alloc] init];
    detailSearch.delegate = self;
    [detailSearch poiDetailSearch:option];
}

#pragma mark - BMKPoiSearchDelegate
/**
 *返回POI详情搜索结果
 *@param searcher 搜索对象
 *@param poiDetailResult 详情搜索结果
 *@param errorCode 错误码，@see BMKSearchErrorCode
 */
- (void)onGetPoiDetailResult:(BMKPoiSearch*)searcher result:(BMKPOIDetailSearchResult*)poiDetailResult errorCode:(BMKSearchErrorCode)errorCode {
    //BMKSearchErrorCode错误码，BMK_SEARCH_NO_ERROR：检索结果正常返回
    if (errorCode == BMK_SEARCH_NO_ERROR) {
        //在此处理正常结果
        NSLog(@"检索结果正常返回:%@", poiDetailResult.poiInfoList);
        BMKPoiInfo *info = poiDetailResult.poiInfoList.firstObject;
        NSLog(@"经纬度：%f-%f", info.pt.latitude, info.pt.longitude);
        if (self.completionHandler) {
            self.completionHandler(info);
        }
    } else {
        NSLog(@"其他检索结果错误码");
    }
}
@end
